/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Inplace.xs. Do not edit this file, edit Inplace.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Syntax/Keyword/Inplace.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2022 -- leonerd@leonerd.org.uk
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "XSParseKeyword.h"

#include "perl-backcompat.c.inc"

enum {
  OPpDUP_MOVEMARK = (1<<0),
};

static XOP xop_dup;
static OP *pp_dup(pTHX)
{
  dSP;
  SV *sv = TOPs;

  if(PL_op->op_flags & OPf_REF)
    XPUSHs(sv);
  else
    XPUSHs(sv_mortalcopy(sv));

  if(PL_op->op_private & OPpDUP_MOVEMARK)
    (*PL_markstack_ptr)++;

  RETURN;
}

#define newDUPOP(flags)  S_newDUPOP(aTHX_ flags)
static OP *S_newDUPOP(pTHX_ U32 flags)
{
  OP *o = newUNOP(OP_CUSTOM, flags, NULL);
  o->op_ppaddr = &pp_dup;
  return o;
}

static bool arg_is_acceptable(OP *argop)
{
  switch(argop->op_type) {
    case OP_PADSV:
    case OP_RV2SV:
    case OP_HELEM:
    case OP_AELEM:
      return TRUE;
  }

  return FALSE;
}

static OP *build_inplace_coreop(pTHX_ OP *op)
{
  /* Turn EXPR... -> OP into  EXPR... -> DUP -> OP -> SASSIGN */
  /* The tree shape of this will be horrible */

  OP *expr = cUNOPx(op)->op_first;

  if(!arg_is_acceptable(expr))
    croak("Cannot use %s as an argument to an inplace operator", PL_op_name[expr->op_type]);

  /* Thread the DUP op in without it appearing structurally */
  OP *dupop = newDUPOP(OPf_REF);

  dupop->op_next = expr->op_next;
  expr->op_next = dupop;

  /* This really weird OP_SASSIGN is a binop with only one child. Don't worry.
   * At runtime it will still see two SVs because of the DUP; but they'll be
   * in the wrong order so we'll have to swap them */
  OP *assignop = newBINOP(OP_SASSIGN, (OPpASSIGN_BACKWARDS << 8), op, newOP(OP_NULL, 0));

  assignop->op_next = op->op_next;
  op->op_next = assignop;

  return assignop;
}

static OP *build_inplace_entersub(pTHX_ OP *op)
{
  OP *args = cUNOPx(op)->op_first;

  if(!args->op_type && args->op_targ == OP_LIST)
    args = cLISTOPx(args)->op_first;

  assert(args->op_type == OP_PUSHMARK);

  OP *arg = OpSIBLING(args);

  /* If this op has a single argument then OpSIBLING of arg will be set,
   * but OpSIBLING of that will be NULL
   */

  if(!OpSIBLING(arg))
    croak("Cannot use a function call with no arguments as an inplace operator");
  if(OpSIBLING(OpSIBLING(arg)))
    croak("Cannot use a function call with more than one argument as an inplace operator");

  if(!arg_is_acceptable(arg))
    croak("Cannot use %s as an argument to an inplace operator", PL_op_name[arg->op_type]);

  OP *start = LINKLIST(op);
  op->op_next = start;

  /* Thread the DUP op in without it appearing structurally */
  OP *dupop = newDUPOP(OPf_REF | (OPpDUP_MOVEMARK << 8));

  dupop->op_next = arg->op_next;
  arg->op_next = dupop;

  /* This really weird OP_SASSIGN is a binop with only one child. Don't worry.
   * At runtime it will still see two SVs because of the DUP; but they'll be
   * in the wrong order so we'll have to swap them */
  OP *assignop = newBINOP(OP_SASSIGN, (OPpASSIGN_BACKWARDS << 8), op, newOP(OP_NULL, 0));

  assignop->op_next = op->op_next;
  op->op_next = assignop;

  return assignop;
}

static int build_inplace(pTHX_ OP **out, XSParseKeywordPiece *arg0, void *hookdata)
{
  OP *op = arg0->op;
  OPCODE optype = op->op_type;

#if 0
  warn("Initial optree:\n");
  op_dump(op);
#endif

  /* Any retscalar + unop is fine */
  if((PL_opargs[optype] & OA_RETSCALAR) &&
      ((PL_opargs[optype] & OA_CLASS_MASK) == OA_UNOP))
    *out = build_inplace_coreop(aTHX_ op);
  /* Any retscalar baseop_or_unop is fine provided it has a kid */
  else if((PL_opargs[optype] & OA_RETSCALAR) &&
      ((PL_opargs[optype] & OA_CLASS_MASK) == OA_BASEOP_OR_UNOP)) {
    if(!(op->op_flags & OPf_KIDS))
      croak("Cannot use %s as an inplace operator without an expression", PL_op_name[optype]);
    *out = build_inplace_coreop(aTHX_ op);
  }
  /* We'll possibly allow entersub but only of a single argument */
  else if(optype == OP_ENTERSUB)
    *out = build_inplace_entersub(aTHX_ op);
  else
    croak("Cannot use %s as an inplace operator", PL_op_name[optype]);

#if 0
  warn("Final optree\n");
  op_dump(*out);
#endif

  return KEYWORD_PLUGIN_EXPR;
}

static const struct XSParseKeywordHooks hooks_inplace = {
  .permit_hintkey = "Syntax::Keyword::Inplace/inplace",
  .piece1 = XPK_TERMEXPR,
  .build1 = &build_inplace,
};

#line 177 "lib/Syntax/Keyword/Inplace.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 321 "lib/Syntax/Keyword/Inplace.c"
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Syntax__Keyword__Inplace); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Syntax__Keyword__Inplace)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif


    /* Initialisation Section */

#line 170 "lib/Syntax/Keyword/Inplace.xs"
  boot_xs_parse_keyword(0.13);

  XopENTRY_set(&xop_dup, xop_name, "dup");
  XopENTRY_set(&xop_dup, xop_desc, "duplicate");
  XopENTRY_set(&xop_dup, xop_class, OA_UNOP);
  Perl_custom_op_register(aTHX_ &pp_dup, &xop_dup);

  register_xs_parse_keyword("inplace", &hooks_inplace, NULL);

#line 356 "lib/Syntax/Keyword/Inplace.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
